.MODULE/ram             Mu_Law_Compression;

{
                This routine determines the 8-bit (right-justified)
                mu-Law value from the 16-bit (right-justified) linear
                input.

                Calling Parameters
        AR = 16-bit (right-justified) linear input

                Return Values
        AR = 8-bit log (mu-Law) output

                Altered Registers
        AR, AF, AX0, AY0,
        SR, SE

                Computation Time
        21 Cycles

}

.ENTRY  u_compress;

u_compress:     AR=ABS AR;                      {Take absolute value}
                AY0=33;                         {Add offset of boundries}
                AR=AR+AY0;
                AY0=8191;                       {Maximum PCM value}
                AF=AR-AY0;                      {Cap input}
                IF GT AR=PASS AY0;              {If in excess}
                SE=EXP AR (HI);                 {Find exponent adjustmet}
                AX0=SE, SR=NORM AR (LO);        {Normalize input}
                AY0=H#4000;
                AR=SR0 XOR AY0;                 {Remove first significant bit}
                SR=LSHIFT AR BY -10 (LO);       {Shift position bits}
                AR=PASS AY0;
                IF POS AR=PASS 0;               {Create sign bit}
                SR=SR OR LSHIFT AR BY -7 (LO);  {Position sign bit}
                AY0=9;
                AR=AX0+AY0;                     {Compute segment}
                IF LT AR=PASS 0;
                SR=SR OR LSHIFT AR BY 4 (LO);   {Position segment bits}
                AY0=H#FF;
                AR=SR0 XOR AY0;                 {Invert bits}
                RTS;

.ENDMOD;
